'' =================================================================================================
'   File......  ParMeter.spin       
'   Purpose...  Reads Apogee MQ-200, the Sun Systems Part# 748200 and the Sun Systems Part# 748205
'   E-mail..... wut@thereisnoelectron.com
'   Author....  Clock Loop @ parallax forums 
'   Started...  9-10-2016
'   Updated...  9-18-2016
'' =================================================================================================

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  
CON

  Tx             = 30   'serial 
  Rx             = 31   'serial
  
  Tx1            = 0
  Rx1            = 1

  'EepromScl      = 28  'eeprom. 
  'EepromSda      = 29  'eeprom.  


  ParTx          = 26   'serial 
  ParRx          = 27   'serial 

  Red            = 17
  Green          = 16
  Blue           = 15
  
VAR
  long  cogon[8], cog[8], pile[2000]   ' cog management
  
OBJ

  Term          : "FullDuplexSerialPlus"    
  Clock         : "PropellerRTC_Emulator"   
  ParMeter      : "FullDuplexSerialPlus"
           
PUB  Start
    
  'Assuming that a 80 MHz core clock is being used, 800 cycles is about 10us.

  'in_pasm(1 + cnt)             'Wait for 12.5 ns   -80 Mhz 
  'in_pasm(8 + cnt)             'Wait for 100 ns    -10 Mhz  
  'in_pasm(80 + cnt)            'Wait for 1us       -1 Mhz      
  'waitcnt(800 + cnt)           'Wait for 10us      -100 Khz
  'waitcnt(8_000 + cnt)         'Wait for 100 us    -10 Khz  
  'waitcnt(80_000 + cnt)        'Wait for 1ms       -1 Khz
  'waitcnt(800_000 + cnt)       'Wait for 10 ms     -100 Hz
  'waitcnt(8_000_000 + cnt)     'Wait for 100 ms    -10 Hz human reaction speed
  'waitcnt(80_000_000 + cnt)    'Wait for 1000 ms   -1 Hz
      
  stop    ' stop all cogs if running  

  term.start(Rx, Tx, %0000, 19_200)                          ' 1cog start terminal

  ParMeter.start(ParTx, ParRx, %0000, 2_400)                    ' 1cog start terminal
  
  cogon[0] := (cog[0] := cognew(UpTime, @pile[0]) > 0)   '1cog 
 
  cogon[1] := (cog[1] := cognew(Display, @pile[100]) > 0)        '2cog

  'cogon[2] := (cog[2] := cognew(NotUsed1, @pile[200]) > 0)    '1cog
  
  'cogon[3] := (cog[3] := cognew(NotUsed2, @pile[300]) > 0)      '1cog

  'cogon[4] := (cog[4] := cognew(NotUsed3, @pile[400]) > 0)      '2cog

  'cogon[5] := (cog[5] := cognew(NotUsed4, @pile[500]) > 0)    
 
  'cogon[6] := (cog[6] := cognew(NotUsed5, @pile[600]) > 0)    

  'cogon[7] := (cog[7] := cognew(NotUsed6, @pile[700]) > 0)

        
Pub UpTime | Ledz

  outa[Red] := 1
  outa[Green] := 1
  outa[Blue] := 1

  dira[Red] := 1   
  dira[Green] := 1
  dira[Blue] := 1
        
  Ledz := 1
  
Repeat
  waitcnt(80_000_000 + cnt)     'wait 1 second.
  Secs := Secs + 1

  If Secs > 59
    Secs := 0
    Mnit := Mnit + 1

  If Mnit > 59
    Mnit := 0
    Hour := Hour + 1
  
  If Hour > 23
    Hour := 0
    Dayz := Dayz + 1

  If Ledz == 1
    outa[Red] := 0 

  If Ledz == 2
    outa[Red] := 1

  If Ledz == 3
    outa[Blue] := 0
    
  If Ledz == 4
    outa[Blue] := 1

  If Ledz == 5 
    outa[Green] := 0
    
  If Ledz == 6                         
    outa[Green] := 1

  Ledz++
  If Ledz > 6
    Ledz := 1
 
                
Pub  Display | tmp, readcount, parcount, parcount1, parcount2
  
  
  term.str(string(27))  'Set command mode          
  term.str(string("[2J")) 'clear screen
  waitcnt(cnt + 80_000_000)
  
  term.str(string(27))    'Set command mode
  term.str(string("[0m")) 'Turn off character attributes
            
  
  term.str(string(27))  'Set command mode  
  term.str(string("[3;3f")) 'position
  term.str(string("Par Meter"))


  ParMeterRead
  readcount := 0
  parcount := 0
  parcount1 := 0
  parcount2 := 0
       
  Repeat
        term.str(string(27))  'Set command mode          
        term.str(string("[2J")) 'clear screen
                     
        term.str(string(27))    'Set command mode
        'term.str(string("[0m")) 'Turn off character attributes
        term.str(string("[1m")) 'Turn bold mode on
        'term.str(string("[2m")) 'Turn low intensity mode on
        'term.str(string("[4m")) 'Turn underline mode on
        'term.str(string("[5m")) 'Turn blinking mode on
        'term.str(string("[7m")) 'Turn reverse video on    
        'term.str(string("[8m")) 'Turn invisible text mode on
     
        'term.str(string("#3"))  'Double-height letters, top half 
        { 
        Esc#3   Double-height letters, top half         DECDHL
        Esc#4   Double-height letters, bottom half      DECDHL
        Esc#5   Single width, single height letters     DECSWL
        Esc#6   Double width, single height letters     DECDWL
        }        

        term.str(string(27))    'Set command mode 
        term.str(string("[3;5f"))  'Set Position 

        term.str(string(27))  'Set command mode 
        term.str(string("[34m")) 'Blue color text
        
        term.str(string("RunTime: "))

        term.str(string(27))    'Set command mode 
        term.str(string("[4;5f"))  'Set Position 
        
        term.dec(Dayz)       
        term.str(string(":Days  "))
        term.dec(Hour)       
        term.str(string(":Hours "))

        term.str(string(27))    'Set command mode 
        term.str(string("[5;5f"))  'Set Position 
                
        term.dec(Mnit)       
        term.str(string(":Min  "))
        term.dec(Secs)       
        term.str(string(":Sec"))

        'term.str(string("[30m")) 'Black color text
        'term.str(string("[31m")) 'Red color text
        'term.str(string("[32m")) 'Lime color text
        'term.str(string("[33m")) 'Yellow color text
        'term.str(string("[34m")) 'Blue color text  
        'term.str(string("[35m")) 'Purple color text
        'term.str(string("[36m")) 'SkyBlue color text  
        'term.str(string("[37m")) 'White color text
        

        term.str(string(27))    'Set command mode 
        term.str(string("[7;5f"))  'Set Position 

        term.str(string(27))  'Set command mode  
        term.str(string("[33m")) 'Yellow color text
        term.str(string("Name string       :"))

        term.str(string(27))    'Set command mode 
        term.str(string("[7;24f"))  'Set Position
        term.str(@ParName)
        term.str(string(","))
        term.dec(ParName)
        term.str(string(","))
        term.dec(strsize(@ParName))

        '--------------------------------------------------------
        
         
        term.str(string(27))    'Set command mode 
        term.str(string("[8;5f"))  'Set Position 
        term.str(string("Decimal info      :"))
        term.dec(ParName.byte[0])
        term.str(string(","))

        term.dec(ParName.byte[1])
        term.str(string(","))

        term.dec(ParName.byte[2])
        term.str(string(","))

        term.dec(ParName.byte[3])
        term.str(string(","))

        term.dec(ParName.byte[4])
        term.str(string(","))

        term.dec(ParName.byte[5])
        term.str(string(","))

        term.dec(ParName.byte[6])
        term.str(string(","))

        term.dec(ParName.byte[7])
        term.str(string(","))

        term.dec(ParName.byte[8])
        term.str(string(","))
          
         
        '--------------------------------------------------------  

        
        term.str(string(27))    'Set command mode 
        term.str(string("[9;5f"))  'Set Position
        term.str(string("Hex info          :"))
        
        term.hex(ParName.byte[0],2)
        term.str(string(","))
        
        term.hex(ParName.byte[1],2)
        term.str(string(","))

        term.hex(ParName.byte[2],2)
        term.str(string(","))
        
        term.hex(ParName.byte[3],2)
        term.str(string(","))
        
        term.hex(ParName.byte[4],2)
        term.str(string(","))
        
        term.hex(ParName.byte[5],2)
        term.str(string(","))
        
        term.hex(ParName.byte[6],2)
        term.str(string(","))
        
        term.hex(ParName.byte[7],2)
        term.str(string(","))

        term.hex(ParName.byte[8],2)
        term.str(string(","))


        '--------------------------------------------------------  
        
        
        term.str(string(27))    'Set command mode 
        term.str(string("[10;5f"))  'Set Position
        term.str(string("Byte info         :"))

        term.str(string(27))    'Set command mode 
        term.str(string("[10;25f"))  'Set Position        
        term.tx(ParName.byte[0])
        term.str(string(","))

        term.str(string(27))    'Set command mode 
        term.str(string("[10;28f"))  'Set Position         
        term.tx(ParName.byte[1])
        term.str(string(","))

        term.str(string(27))    'Set command mode 
        term.str(string("[10;31f"))  'Set Position 
        term.tx(ParName.byte[2])
        term.str(string(","))

        term.str(string(27))    'Set command mode 
        term.str(string("[10;34f"))  'Set Position 
        term.tx(ParName.byte[3])
        term.str(string(","))        

        term.str(string(27))    'Set command mode 
        term.str(string("[10;37f"))  'Set Position 
        term.tx(ParName.byte[4])
        term.str(string(","))

        term.str(string(27))    'Set command mode 
        term.str(string("[10;40f"))  'Set Position 
        term.tx(ParName.byte[5])
        term.str(string(","))

        term.str(string(27))    'Set command mode 
        term.str(string("[10;43f"))  'Set Position 
        term.tx(ParName.byte[6])
        term.str(string(","))

        term.str(string(27))    'Set command mode 
        term.str(string("[10;46f"))  'Set Position 
        term.tx(ParName.byte[7])        
        term.str(string(" ,"))

        term.str(string(27))    'Set command mode 
        term.str(string("[10;49f"))  'Set Position 
        term.tx(ParName.byte[8])        
        term.str(string(" ,"))

        
        '--------------------------------------------------------

        
        term.str(string(27))    'Set command mode 
        term.str(string("[11;5f"))  'Set Position
        term.str(string("Bit  info        0:"))
        
        term.str(string(27))    'Set command mode 
        term.str(string("[11;24f"))  'Set Position        
        term.bin(ParName.byte[0],8)

        term.str(string(27))    'Set command mode 
        term.str(string("[12;22f"))  'Set Position
        term.str(string("1:"))    
        term.bin(ParName.byte[1],8)

        term.str(string(27))    'Set command mode 
        term.str(string("[13;22f"))  'Set Position
        term.str(string("2:"))    
        term.bin(ParName.byte[2],8)

        term.str(string(27))    'Set command mode 
        term.str(string("[14;22f"))  'Set Position
        term.str(string("3:"))    
        term.bin(ParName.byte[3],8)

        term.str(string(27))    'Set command mode 
        term.str(string("[15;22f"))  'Set Position
        term.str(string("4:"))    
        term.bin(ParName.byte[4],8)

        term.str(string(27))    'Set command mode 
        term.str(string("[16;22f"))  'Set Position
        term.str(string("5:"))    
        term.bin(ParName.byte[5],8)

        term.str(string(27))    'Set command mode 
        term.str(string("[17;22f"))  'Set Position
        term.str(string("6:"))    
        term.bin(ParName.byte[6],8)

        term.str(string(27))    'Set command mode 
        term.str(string("[18;22f"))  'Set Position
        term.str(string("7:"))    
        term.bin(ParName.byte[7],8)

        term.str(string(27))    'Set command mode 
        term.str(string("[19;22f"))  'Set Position
        term.str(string("8:"))    
        term.bin(ParName.byte[8],8)

         
        '--------------------------------------------------------
         
        
        term.str(string(27))    'Set command mode 
        term.str(string("[20;5f"))  'Set Position 
                             
        term.str(string(27))  'Set command mode  
        term.str(string("[33m")) 'Yellow color text   
        term.str(string("30 Minute Average :"))

        Repeat parcount from 0 to 98
          term.dec(Par30min[parcount])
          
          term.str(string(","))
          If parcount == 11
            term.str(string(27))    'Set command mode 
            term.str(string("[21;24f"))  'Set Position
          If parcount == 23
            term.str(string(27))    'Set command mode 
            term.str(string("[22;24f"))  'Set Position
          If parcount == 35
            term.str(string(27))    'Set command mode 
            term.str(string("[23;24f"))  'Set Position
          If parcount == 47
            term.str(string(27))    'Set command mode 
            term.str(string("[24;24f"))  'Set Position
          If parcount == 59
            term.str(string(27))    'Set command mode 
            term.str(string("[25;24f"))  'Set Position
          If parcount == 71
            term.str(string(27))    'Set command mode 
            term.str(string("[26;24f"))  'Set Position
          If parcount == 83
            term.str(string(27))    'Set command mode 
            term.str(string("[27;24f"))  'Set Position


        '--------------------------------------------------------
        
        
        term.str(string(27))    'Set command mode 
        term.str(string("[29;5f"))  'Set Position

        term.str(string(27))  'Set command mode  
        term.str(string("[33m")) 'Yellow color text   
        term.str(string("Daily Par Totals  :"))
        Repeat parcount1 from 0 to 98
          term.dec(ParDaily[parcount1])
          term.str(string(","))
          If parcount1 == 11
            term.str(string(27))    'Set command mode 
            term.str(string("[30;24f"))  'Set Position
          If parcount1 == 23
            term.str(string(27))    'Set command mode 
            term.str(string("[31;24f"))  'Set Position
          If parcount1 == 35
            term.str(string(27))    'Set command mode 
            term.str(string("[32;24f"))  'Set Position
          If parcount1 == 47
            term.str(string(27))    'Set command mode 
            term.str(string("[33;24f"))  'Set Position
          If parcount1 == 59
            term.str(string(27))    'Set command mode 
            term.str(string("[34;24f"))  'Set Position
          If parcount1 == 71
            term.str(string(27))    'Set command mode 
            term.str(string("[35;24f"))  'Set Position
          If parcount1 == 83
            term.str(string(27))    'Set command mode 
            term.str(string("[36;24f"))  'Set Position


        '--------------------------------------------------------

        
        term.str(string(27))    'Set command mode 
        term.str(string("[38;5f"))  'Set Position

        term.str(string(27))  'Set command mode  
        term.str(string("[33m")) 'Yellow color text   
        term.str(string("ParSample         :"))

        Repeat parcount2 from 0 to 98
          term.dec(ParSample[parcount2])
          term.str(string(","))
          If parcount2 == 11
            term.str(string(27))    'Set command mode 
            term.str(string("[39;24f"))  'Set Position
          If parcount2 == 23
            term.str(string(27))    'Set command mode 
            term.str(string("[40;24f"))  'Set Position
          If parcount2 == 35
            term.str(string(27))    'Set command mode 
            term.str(string("[41;24f"))  'Set Position
          If parcount2 == 47
            term.str(string(27))    'Set command mode 
            term.str(string("[42;24f"))  'Set Position
          If parcount2 == 59
            term.str(string(27))    'Set command mode 
            term.str(string("[43;24f"))  'Set Position
          If parcount2 == 71
            term.str(string(27))    'Set command mode 
            term.str(string("[44;24f"))  'Set Position
          If parcount2 == 83
            term.str(string(27))    'Set command mode 
            term.str(string("[45;24f"))  'Set Position


        '--------------------------------------------------------
        
        
        waitcnt(80_000_000 + cnt)
        
        If readcount > 30
          ParMeterRead 
          readcount := 0
        Else
          readcount++  
         

        
Pub ParMeterRead | rollcount0, rollcount1, rollcount2


  rollcount0 := 0
  ParName[0] := 0
  ParName[1] := 0   
  ParMeter.tx($08)
  If ParMeter.rx == $08
    Repeat rollcount0 from 0 to 8
      ParName.byte[rollcount0] := ParMeter.rx      
      If ParName.byte[rollcount0] == $1A
        ParName.byte[rollcount0] := $00

        
  rollcount1 := 0
  rollcount2 := 0
  Repeat rollcount1 from 0 to 99 
    Par30Min[rollcount1] := 0 

  Repeat rollcount2 from 0 to 6
    StrPar.byte[rollcount2] := 0

  rollcount1 := 0
  rollcount2 := 0


  waitcnt(1_000_000 + cnt) 
  ParMeter.tx($31)
  ParMeter.tx($0A)  
  If ParMeter.rx == $31
    If ParMeter.rx == $0A
      Repeat rollcount1 from 0 to 99
        Repeat rollcount2 from 0 to 6
          StrPar.byte[rollcount2] := ParMeter.rxtime(5)
          
          If StrPar.byte[rollcount2] == $0D
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == $0A
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == -1
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == $1A
            StrPar.byte[rollcount2] := $00
              
        Par30Min[rollcount1] := ParMeter.StrToDec(@StrPar)

  
  waitcnt(1_000_000 + cnt)
  rollcount1 := 0
  rollcount2 := 0
  Repeat rollcount1 from 0 to 99 
    ParDaily[rollcount1] := 0
    
  Repeat rollcount2 from 0 to 6
    StrPar.byte[rollcount2] := 0

  rollcount1 := 0
  rollcount2 := 0       

  ParMeter.tx($32)
  ParMeter.tx($0A)  
  If ParMeter.rx == $32
    If ParMeter.rx == $0A
      Repeat rollcount1 from 0 to 99
        Repeat rollcount2 from 0 to 6
          StrPar.byte[rollcount2] := ParMeter.rxtime(5)
          
          If StrPar.byte[rollcount2] == $0D
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == $0A
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == -1
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == $1A
            StrPar.byte[rollcount2] := $00
              
        ParDaily[rollcount1] := ParMeter.StrToDec(@StrPar)

        
  waitcnt(1_000_000 + cnt)          
  rollcount1 := 0
  rollcount2 := 0
  Repeat rollcount1 from 0 to 99 
    ParSample[rollcount1] := 0

  Repeat rollcount2 from 0 to 6
    StrPar.byte[rollcount2] := 0

  rollcount1 := 0
  rollcount2 := 0 

  
  ParMeter.tx($33)
  ParMeter.tx($0A)  
  If ParMeter.rx == $33
    If ParMeter.rx == $0A
      Repeat rollcount1 from 0 to 99
        Repeat rollcount2 from 0 to 6
          StrPar.byte[rollcount2] := ParMeter.rxtime(5)
          
          If StrPar.byte[rollcount2] == $0D
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == $0A
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == -1
            StrPar.byte[rollcount2] := $00
          ElseIf StrPar.byte[rollcount2] == $1A
            StrPar.byte[rollcount2] := $00
              
        ParSample[rollcount1] := ParMeter.StrToDec(@StrPar)
        
        

PUB stop


'' Unload timer object - frees a cog

  if cogon[0]~                                          ' if object running, mark stopped
    cogstop(cog[0])

  if cogon[1]~                                          ' if object running, mark stopped
    cogstop(cog[1])
    
  if cogon[2]~                                          ' if object running, mark stopped
    cogstop(cog[2])

  if cogon[3]~                                          ' if object running, mark stopped
    cogstop(cog[3])
 
  if cogon[4]~                                          ' if object running, mark stopped
    cogstop(cog[4])

  if cogon[5]~                                          ' if object running, mark stopped
    cogstop(cog[5])

  if cogon[6]~                                          ' if object running, mark stopped
    cogstop(cog[6])
    
  if cogon[7]~                                          ' if object running, mark stopped
    cogstop(cog[7])
          
Dat
  
  Secs                  long    0
  Mnit                  long    0
  Hour                  long    0
  Dayz                  long    0
                               
  ParName               long    0,0,0,0,0,0,0,0,0,0
                        
  StrPar                long    0,0,0,0,0,0,0,0,0,0

  Par30min              long    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
                        long    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  
  ParDaily              long    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 
                        long    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  
  ParSample             long    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                        long    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                 
Dat
{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 

}}    